#!/bin/sh
#
# Init usb cdc net...
#

start()
{
	kernel_ver=$(uname -r)

#	echo device > /proc/ambarella/uport

	#Install USB module
	if [ -r /lib/modules/$kernel_ver/kernel/drivers/usb/gadget/udc-core.ko ]; then
		modprobe udc-core
	fi
	if [ -r /lib/modules/$kernel_ver/kernel/drivers/usb/gadget/ambarella_udc.ko ]; then
		modprobe ambarella_udc
	fi
	if [ -r /lib/modules/$kernel_ver/kernel/drivers/usb/gadget/libcomposite.ko ]; then
		modprobe libcomposite
	fi

	if [ -r /lib/modules/$kernel_ver/kernel/drivers/net/usb/cdc_ether.ko ]; then
		modprobe cdc_ether
	fi
	if [ -r /lib/modules/$kernel_ver/kernel/drivers/usb/gadget/g_cdc.ko ]; then
		modprobe g_cdc 
	fi
	
#	ifconfig usb0 up
#	ifconfig usb0 192.168.1.6 netmask 255.255.255.0
	
}

stop()
{
	kernel_ver=$(uname -r)
#	ifconfig usb0 down
	rmmod g_cdc
	rmmod cdc_ether
	rmmod libcomposite
	rmmod ambarella_udc
	rmmod udc-core
}

restart()
{
	stop
	start
}

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	restart|reload)
		restart
		;;
	*)
		echo "Usage: $0 {start|stop|restart}"
		exit 1
esac

exit $?


