#!/bin/sh

if [ $# -ne 2 ]; then
	echo "usage: $0 93 0"
	exit 0
fi

proc_gpio()
{
	echo "t gpio ${1} sw out${2}"

	gpiohex=`printf %02x ${1}`

	# "C"onfig gpio sw output (0x1)
	echo -en 'c\x'"${gpiohex}"'\x01' > /proc/ambarella/gpio

	if [ "${2}" == "0" ]; then
		# "W"rite output 1(0x0)
		echo -en 'w\x'"${gpiohex}"'\x00' > /proc/ambarella/gpio
	fi

	if [ "${2}" == "1" ]; then
		# "W"rite output 1(0x1)
		echo -en 'w\x'"${gpiohex}"'\x01' > /proc/ambarella/gpio
	fi
}

sys_gpio()
{
	echo "t gpio ${1} sw out${2}"

	if [ ! -e /sys/class/gpio/gpio${1} ]; then
		cd /sys/class/gpio/
		echo ${1} > export
		cd gpio${1}/
		echo out > direction
	fi

	if [ -e /sys/class/gpio/gpio${1} ]; then
		cd /sys/class/gpio/gpio${1}/
		if [ "${2}" == "0" ]; then
			echo 0 > value
		elif [ "${2}" == "1" ]; then
			echo 1 > value
		fi
	fi
}

if [ -e /proc/ambarella/gpio ]; then
	proc_gpio ${1} ${2}
elif [ -e /sys/class/gpio ]; then
	sys_gpio ${1} ${2}
else
	echo "/proc/ambarella/gpio does not exist"
	exit 0
fi

